DECLARE FUNCTION verarbeite$ (stri AS STRING, opti AS INTEGER)

DEFINT A-Z
CLS

PRINT "QBasic Optimizer"

' +++++++++++++ Command$ berprfen +++++++++++++++

p = INSTR(COMMAND$, " ")
IF p THEN
   datei1$ = RTRIM$(LEFT$(COMMAND$, p - 1))
   tmp$ = LTRIM$(RTRIM$(MID$(COMMAND$, p + 1)))

   q = INSTR(tmp$, " ")

   IF q THEN
      datei2$ = LEFT$(tmp$, q - 1)
      opt$ = MID$(tmp$, q + 1)
   ELSE
      datei2$ = tmp$
   END IF

ELSE
  PRINT "Fehlerhafte Verwendung"
  PRINT
  PRINT "   Optimize eingabe.bas ausgabe.bas [-s]"
  PRINT
  PRINT "   -s   Komentare erhalten"
  PRINT
  END
END IF


' +++++++++++ Option berprfen ++++++++++++

IF opt$ = "-S" THEN
   opti = -1
END IF

IF opti THEN
   PRINT "Keine Komentarentfernung"
END IF


' +++++++++++++ .bas anhngen ++++++++++++++

IF INSTR(datei1$, ".") = 0 THEN datei1$ = datei1$ + ".bas"
IF INSTR(datei2$, ".") = 0 THEN datei2$ = datei2$ + ".bas"
   

' +++++++++++ Datei bearbeiten +++++++++++++

OPEN datei1$ FOR INPUT AS 1
OPEN datei2$ FOR OUTPUT AS 2

DO UNTIL EOF(1)
  LINE INPUT #1, zeile$

  PRINT #2, verarbeite(zeile$, opti)
LOOP

CLOSE 1, 2

DEFSNG A-Z
FUNCTION verarbeite$ (stri AS STRING, opti AS INTEGER)

DIM s AS STRING

s = RTRIM$(stri)

endpos = LEN(s)

FOR i = 1 TO LEN(s)
   IF MID$(s, i, 1) = CHR$(34) THEN
      instring = NOT instring
      
   END IF

   IF NOT instring AND NOT opti THEN

      IF MID$(s, i, 1) = "'" THEN
         IF MID$(s, i + 2, 1) <> "$" THEN endpos = i - 1
         EXIT FOR

      ELSEIF MID$(s, i, 3) = "REM" THEN
         IF MID$(s, i + 4, 1) <> "$" THEN endpos = i - 1
         EXIT FOR
               
      END IF

   END IF

NEXT

verarbeite$ = RTRIM$(LEFT$(s, endpos))

END FUNCTION

